Index: trunk/src/VBox/Runtime/common/dbg/dbgmoddbghelp.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/dbg/dbgmoddbghelp.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/common/dbg/dbgmoddbghelp.cpp	(revision 76409)
@@ -41,4 +41,5 @@
 #include <iprt/path.h>
 #include <iprt/string.h>
+#include <iprt/utf16.h>
 #include "internal/dbgmod.h"
 
Index: trunk/src/VBox/Runtime/common/dbg/dbgstackdumpself.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/dbg/dbgstackdumpself.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/common/dbg/dbgstackdumpself.cpp	(revision 76409)
@@ -48,4 +48,5 @@
 #ifdef RT_OS_WINDOWS
 # include <iprt/param.h>
+# include <iprt/utf16.h>
 # include <iprt/win/windows.h>
 #elif defined(RT_OS_LINUX)
Index: trunk/src/VBox/Runtime/common/path/RTPathGlob.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/path/RTPathGlob.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/common/path/RTPathGlob.cpp	(revision 76409)
@@ -44,4 +44,5 @@
 
 #if defined(RT_OS_WINDOWS)
+# include <iprt/utf16.h>
 # include <iprt/win/windows.h>
 # include "../../r3/win/internal-r3-win.h"
Index: trunk/src/VBox/Runtime/generic/http-curl.cpp
===================================================================
--- trunk/src/VBox/Runtime/generic/http-curl.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/generic/http-curl.cpp	(revision 76409)
@@ -59,4 +59,5 @@
 #include <iprt/uni.h>
 #include <iprt/uri.h>
+#include <iprt/utf16.h>
 #include <iprt/crypto/digest.h>
 #include <iprt/crypto/pkix.h>
Index: trunk/src/VBox/Runtime/r0drv/nt/ntBldSymDb.cpp
===================================================================
--- trunk/src/VBox/Runtime/r0drv/nt/ntBldSymDb.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r0drv/nt/ntBldSymDb.cpp	(revision 76409)
@@ -35,4 +35,5 @@
 #include <iprt/dir.h>
 #include <iprt/file.h>
+#include <iprt/err.h>
 #include <iprt/getopt.h>
 #include <iprt/initterm.h>
@@ -43,5 +44,5 @@
 #include <iprt/stream.h>
 #include <iprt/string.h>
-#include <iprt/err.h>
+#include <iprt/utf16.h>
 
 #include "r0drv/nt/symdb.h"
Index: trunk/src/VBox/Runtime/r3/init.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/init.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/init.cpp	(revision 76409)
@@ -61,4 +61,7 @@
 #include <iprt/string.h>
 #include <iprt/param.h>
+#ifdef RT_OS_WINDOWS
+# include <iprt/utf16.h>
+#endif
 #if !defined(IN_GUEST) && !defined(RT_NO_GIP)
 # include <iprt/file.h>
Index: trunk/src/VBox/Runtime/r3/nt/direnum-r3-nt.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/nt/direnum-r3-nt.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/nt/direnum-r3-nt.cpp	(revision 76409)
@@ -40,4 +40,5 @@
 #include <iprt/file.h>
 #include <iprt/log.h>
+#include <iprt/utf16.h>
 #include "internal/fs.h"
 #include "internal/dir.h"
Index: trunk/src/VBox/Runtime/r3/nt/dirrel-r3-nt.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/nt/dirrel-r3-nt.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/nt/dirrel-r3-nt.cpp	(revision 76409)
@@ -39,4 +39,5 @@
 #include <iprt/string.h>
 #include <iprt/symlink.h>
+#include <iprt/utf16.h>
 #include "internal/dir.h"
 #include "internal/file.h"
Index: trunk/src/VBox/Runtime/r3/nt/pathint-nt.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/nt/pathint-nt.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/nt/pathint-nt.cpp	(revision 76409)
@@ -32,9 +32,10 @@
 #include "internal-r3-nt.h"
 
+#include <iprt/assert.h>
+#include <iprt/err.h>
+#include <iprt/mem.h>
 #include <iprt/path.h>
-#include <iprt/mem.h>
 #include <iprt/string.h>
-#include <iprt/err.h>
-#include <iprt/assert.h>
+#include <iprt/utf16.h>
 
 
Index: trunk/src/VBox/Runtime/r3/stream.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/stream.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/stream.cpp	(revision 76409)
@@ -59,4 +59,5 @@
 #endif
 #ifdef RT_OS_WINDOWS
+# include <iprt/utf16.h>
 # include <iprt/win/windows.h>
 #else
Index: trunk/src/VBox/Runtime/r3/win/RTSystemQueryDmiString-win.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/win/RTSystemQueryDmiString-win.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/win/RTSystemQueryDmiString-win.cpp	(revision 76409)
@@ -39,4 +39,5 @@
 #include <iprt/assert.h>
 #include <iprt/string.h>
+#include <iprt/utf16.h>
 
 
Index: trunk/src/VBox/Runtime/r3/win/RTSystemQueryOSInfo-win.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/win/RTSystemQueryOSInfo-win.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/win/RTSystemQueryOSInfo-win.cpp	(revision 76409)
@@ -39,4 +39,5 @@
 #include <iprt/err.h>
 #include <iprt/string.h>
+#include <iprt/utf16.h>
 
 
Index: trunk/src/VBox/Runtime/r3/win/RTSystemShutdown-win.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/win/RTSystemShutdown-win.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/win/RTSystemShutdown-win.cpp	(revision 76409)
@@ -35,4 +35,5 @@
 #include <iprt/err.h>
 #include <iprt/string.h>
+#include <iprt/utf16.h>
 
 #include <iprt/win/windows.h>
Index: trunk/src/VBox/Runtime/r3/win/RTTimeZoneGetCurrent-win.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/win/RTTimeZoneGetCurrent-win.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/win/RTTimeZoneGetCurrent-win.cpp	(revision 76409)
@@ -35,4 +35,5 @@
 #include <iprt/env.h>
 #include <iprt/string.h>
+#include <iprt/utf16.h>
 #include <iprt/win/windows.h>
 #include "internal-r3-win.h"
Index: trunk/src/VBox/Runtime/r3/win/env-win.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/win/env-win.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/win/env-win.cpp	(revision 76409)
@@ -36,4 +36,5 @@
 #include <iprt/string.h>
 #include <iprt/mem.h>
+#include <iprt/utf16.h>
 
 #include <stdlib.h>
Index: trunk/src/VBox/Runtime/r3/win/ldrNative-win.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/win/ldrNative-win.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/win/ldrNative-win.cpp	(revision 76409)
@@ -41,9 +41,9 @@
 #include <iprt/file.h>
 #include <iprt/log.h>
+#include <iprt/once.h>
 #include <iprt/path.h>
 #include <iprt/string.h>
-
-#include <iprt/once.h>
-#include <iprt/string.h>
+#include <iprt/utf16.h>
+
 #include "internal/ldr.h"
 #include "internal-r3-win.h"
Index: trunk/src/VBox/Runtime/r3/win/localipc-win.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/win/localipc-win.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/win/localipc-win.cpp	(revision 76409)
@@ -60,4 +60,5 @@
 #include <iprt/thread.h>
 #include <iprt/time.h>
+#include <iprt/utf16.h>
 
 #include "internal/magics.h"
Index: trunk/src/VBox/Runtime/r3/win/path-win.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/win/path-win.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/win/path-win.cpp	(revision 76409)
@@ -35,11 +35,12 @@
 #include <iprt/path.h>
 #include <iprt/assert.h>
+#include <iprt/err.h>
+#include <iprt/ldr.h>
+#include <iprt/log.h>
+#include <iprt/mem.h>
+#include <iprt/param.h>
 #include <iprt/string.h>
 #include <iprt/time.h>
-#include <iprt/ldr.h>
-#include <iprt/mem.h>
-#include <iprt/param.h>
-#include <iprt/log.h>
-#include <iprt/err.h>
+#include <iprt/utf16.h>
 #include "internal/path.h"
 #include "internal/fs.h"
Index: trunk/src/VBox/Runtime/r3/win/pathint-win.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/win/pathint-win.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/win/pathint-win.cpp	(revision 76409)
@@ -36,4 +36,5 @@
 #include <iprt/err.h>
 #include <iprt/string.h>
+#include <iprt/utf16.h>
 
 #include <iprt/nt/nt-and-windows.h>
Index: trunk/src/VBox/Runtime/r3/win/process-win.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/win/process-win.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/win/process-win.cpp	(revision 76409)
@@ -62,5 +62,5 @@
 #include <iprt/string.h>
 #include <iprt/socket.h>
-
+#include <iprt/utf16.h>
 
 
Index: trunk/src/VBox/Runtime/r3/win/rtProcInitExePath-win.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/win/rtProcInitExePath-win.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/win/rtProcInitExePath-win.cpp	(revision 76409)
@@ -32,9 +32,10 @@
 #include <iprt/win/windows.h>
 
-#include <iprt/string.h>
 #include <iprt/assert.h>
 #include <iprt/err.h>
 #include <iprt/path.h>
 #include <iprt/param.h>
+#include <iprt/string.h>
+#include <iprt/utf16.h>
 #include "internal/process.h"
 
Index: trunk/src/VBox/Runtime/r3/win/shmem-win.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/win/shmem-win.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/win/shmem-win.cpp	(revision 76409)
@@ -40,4 +40,5 @@
 #include <iprt/mem.h>
 #include <iprt/string.h>
+#include <iprt/utf16.h>
 #include "internal/magics.h"
 #include "internal/path.h"
Index: trunk/src/VBox/Runtime/r3/win/symlink-win.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/win/symlink-win.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/win/symlink-win.cpp	(revision 76409)
@@ -41,4 +41,5 @@
 #include <iprt/mem.h>
 #include <iprt/string.h>
+#include <iprt/utf16.h>
 #include "internal/path.h"
 
Index: trunk/src/VBox/Runtime/r3/win/utf16locale-win.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/win/utf16locale-win.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/win/utf16locale-win.cpp	(revision 76409)
@@ -32,5 +32,5 @@
 #include <iprt/win/windows.h>
 
-#include <iprt/string.h>
+#include <iprt/utf16.h>
 
 
Index: trunk/src/VBox/Runtime/r3/win/utf8-win.cpp
===================================================================
--- trunk/src/VBox/Runtime/r3/win/utf8-win.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/r3/win/utf8-win.cpp	(revision 76409)
@@ -36,4 +36,5 @@
 #include <iprt/assert.h>
 #include <iprt/err.h>
+#include <iprt/utf16.h>
 
 
Index: trunk/src/VBox/Runtime/testcase/tstRTGetOptArgv.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTGetOptArgv.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/testcase/tstRTGetOptArgv.cpp	(revision 76409)
@@ -32,9 +32,10 @@
 
 #include <iprt/err.h>
-#include <iprt/param.h>
 #include <iprt/getopt.h>
 #include <iprt/ldr.h>
+#include <iprt/param.h>
 #include <iprt/string.h>
 #include <iprt/test.h>
+#include <iprt/utf16.h>
 
 
Index: trunk/src/VBox/Runtime/testcase/tstRTNtPath-1.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTNtPath-1.cpp	(revision 76408)
+++ trunk/src/VBox/Runtime/testcase/tstRTNtPath-1.cpp	(revision 76409)
@@ -37,4 +37,5 @@
 #include <iprt/string.h>
 #include <iprt/test.h>
+#include <iprt/utf16.h>
 
 