Index: /trunk/include/iprt/errcore.h
===================================================================
--- /trunk/include/iprt/errcore.h	(revision 76422)
+++ /trunk/include/iprt/errcore.h	(revision 76423)
@@ -803,4 +803,7 @@
  * @ingroup grp_rt_err */
 #define VERR_INVALID_FLAGS                  (-13)
+/** Incorrect call order.
+ * @ingroup grp_rt_err */
+#define VERR_WRONG_ORDER                    (-22)
 /** Invalid function.
  * @ingroup grp_rt_err */
@@ -836,4 +839,22 @@
  * @ingroup grp_rt_err */
 #define VERR_TOO_MUCH_DATA                  (-42)
+/** Retry the operation.
+ * @ingroup grp_rt_err */
+#define VERR_TRY_AGAIN                      (-52)
+/** Retry the operation.
+ * @ingroup grp_rt_err */
+#define VINF_TRY_AGAIN                      52
+/** Generic parse error.
+ * @ingroup grp_rt_err */
+#define VERR_PARSE_ERROR                    (-53)
+/** Value out of range.
+ * @ingroup grp_rt_err */
+#define VERR_OUT_OF_RANGE                   (-54)
+/** A numeric conversion encountered a value which was too big for the target.
+ * @ingroup grp_rt_err */
+#define VERR_NUMBER_TOO_BIG                 (-55)
+/** A numeric conversion encountered a value which was too big for the target.
+ * @ingroup grp_rt_err */
+#define VWRN_NUMBER_TOO_BIG                 55
 /** The operation was cancelled by the user (copy) or another thread (local ipc).
  * @ingroup grp_rt_err */
@@ -872,4 +893,10 @@
  * @ingroup grp_rt_err */
 #define VERR_END_OF_STRING                  (-83)
+/** Return instigated by a callback or similar.
+ * @ingroup grp_rt_err */
+#define VERR_CALLBACK_RETURN                (-88)
+/** Return instigated by a callback or similar.
+ * @ingroup grp_rt_err */
+#define VINF_CALLBACK_RETURN                88
 /** Duplicate something.
  * @ingroup grp_rt_err */
@@ -914,5 +941,7 @@
  * @ingroup grp_rt_err */
 #define VERR_INTERNAL_ERROR                 (-225)
-
+/** RTGetOpt: Not an option.
+ * @ingroup grp_rt_err */
+#define VINF_GETOPT_NOT_OPTION              828
 
 /** @} */
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxFBOverlay.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxFBOverlay.h	(revision 76422)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxFBOverlay.h	(revision 76423)
@@ -48,5 +48,4 @@
 #include <iprt/critsect.h>
 #include <iprt/asm.h>
-#include <iprt/err.h>
 #include <iprt/list.h>
 #include <VBox/VBoxGL2D.h>
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/COMDefs.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/COMDefs.cpp	(revision 76422)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/COMDefs.cpp	(revision 76423)
@@ -44,8 +44,4 @@
 
 /* Other VBox includes: */
-# include <iprt/env.h>
-# include <iprt/err.h>
-# include <iprt/path.h>
-# include <iprt/param.h>
 # include <nsEventQueueUtils.h>
 # include <nsIEventQueue.h>
Index: /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 76422)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/globals/UIMessageCenter.cpp	(revision 76423)
@@ -91,5 +91,5 @@
 #endif /* !VBOX_WITH_PRECOMPILED_HEADERS */
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/net/UIUpdateManager.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/net/UIUpdateManager.cpp	(revision 76422)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/net/UIUpdateManager.cpp	(revision 76423)
@@ -47,5 +47,5 @@
 
 /* Other VBox includes: */
-# include <iprt/err.h>
+//# include <iprt/err.h>
 # include <iprt/path.h>
 # include <iprt/system.h>
Index: /trunk/src/VBox/Frontends/VirtualBox/src/platform/darwin/DarwinKeyboard.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/platform/darwin/DarwinKeyboard.cpp	(revision 76422)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/platform/darwin/DarwinKeyboard.cpp	(revision 76423)
@@ -37,5 +37,5 @@
 #endif
 #ifdef VBOX_WITH_KBD_LEDS_SYNC
-# include <iprt/err.h>
+# include <iprt/errcore.h>
 # include <iprt/semaphore.h>
 # include <VBox/sup.h>
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIDnDDataObject_win.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIDnDDataObject_win.cpp	(revision 76422)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIDnDDataObject_win.cpp	(revision 76423)
@@ -16,7 +16,4 @@
  */
 
-#ifdef LOG_GROUP
-# undef LOG_GROUP
-#endif
 #define LOG_GROUP LOG_GROUP_GUEST_DND
 #include <VBox/log.h>
@@ -27,5 +24,5 @@
 
 #include <iprt/mem.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/path.h>
 #include <iprt/semaphore.h>
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIDnDMIMEData.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIDnDMIMEData.cpp	(revision 76422)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIDnDMIMEData.cpp	(revision 76423)
@@ -34,5 +34,5 @@
 #define LOG_GROUP LOG_GROUP_GUEST_DND
 #include <VBox/log.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp	(revision 76422)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp	(revision 76423)
@@ -91,7 +91,5 @@
 #include <VBox/VBoxOGL.h>
 #include <VBoxVideo.h>
-#ifdef VBOX_WS_MAC
-# include <VBox/err.h>
-#endif /* VBOX_WS_MAC */
+#include <iprt/errcore.h>
 
 /* External includes: */
@@ -1579,10 +1577,11 @@
 
 #ifdef VBOX_WITH_DRAG_AND_DROP
+
 bool UIMachineView::dragAndDropCanAccept(void) const
 {
     bool fAccept =  m_pDnDHandler
-#ifdef VBOX_WITH_DRAG_AND_DROP_GH
+# ifdef VBOX_WITH_DRAG_AND_DROP_GH
                  && !m_fIsDraggingFromGuest
-#endif
+# endif
                  && machine().GetDnDMode() != KDnDMode_Disabled;
     return fAccept;
@@ -1668,5 +1667,5 @@
     if (!dragAndDropIsActive())
         rc = VERR_ACCESS_DENIED;
-#ifdef VBOX_WITH_DRAG_AND_DROP_GH
+# ifdef VBOX_WITH_DRAG_AND_DROP_GH
     else if (!m_fIsDraggingFromGuest)
     {
@@ -1679,7 +1678,7 @@
     else /* Already dragging, so report success. */
         rc = VINF_SUCCESS;
-#else
+# else
     rc = VERR_NOT_SUPPORTED;
-#endif
+# endif
 
     DNDDEBUG(("DnD: dragCheckPending ended with rc=%Rrc\n", rc));
@@ -1693,5 +1692,5 @@
     if (!dragAndDropIsActive())
         rc = VERR_ACCESS_DENIED;
-#ifdef VBOX_WITH_DRAG_AND_DROP_GH
+# ifdef VBOX_WITH_DRAG_AND_DROP_GH
     else if (!m_fIsDraggingFromGuest)
         rc = VERR_WRONG_ORDER;
@@ -1704,7 +1703,7 @@
         m_fIsDraggingFromGuest = false;
     }
-#else
+# else
     rc = VERR_NOT_SUPPORTED;
-#endif
+# endif
 
     DNDDEBUG(("DnD: dragStart ended with rc=%Rrc\n", rc));
@@ -1718,12 +1717,12 @@
     if (!dragAndDropIsActive())
         rc = VERR_ACCESS_DENIED;
-#ifdef VBOX_WITH_DRAG_AND_DROP_GH
+# ifdef VBOX_WITH_DRAG_AND_DROP_GH
     else if (!m_fIsDraggingFromGuest)
         rc = VERR_WRONG_ORDER;
     else
         rc = m_pDnDHandler->dragStop(screenId());
-#else
+# else
     rc = VERR_NOT_SUPPORTED;
-#endif
+# endif
 
     DNDDEBUG(("DnD: dragStop ended with rc=%Rrc\n", rc));
@@ -1756,4 +1755,5 @@
     DNDDEBUG(("DnD: dropEvent ended with rc=%Rrc\n", rc));
 }
+
 #endif /* VBOX_WITH_DRAG_AND_DROP */
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsLanguage.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsLanguage.cpp	(revision 76422)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/global/UIGlobalSettingsLanguage.cpp	(revision 76423)
@@ -40,5 +40,5 @@
 
 /* Other VBox includes: */
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 
 