Index: trunk/src/VBox/Runtime/testcase/tstFile.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstFile.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstFile.cpp	(revision 76452)
@@ -30,5 +30,5 @@
 *********************************************************************************************************************************/
 #include <iprt/file.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/string.h>
 #include <iprt/stream.h>
Index: trunk/src/VBox/Runtime/testcase/tstIprtMiniString.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstIprtMiniString.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstIprtMiniString.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/cpp/ministring.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/mem.h>
 #include <iprt/string.h>
Index: trunk/src/VBox/Runtime/testcase/tstLdr-2.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstLdr-2.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstLdr-2.cpp	(revision 76452)
@@ -35,5 +35,5 @@
 #include <iprt/initterm.h>
 #include <VBox/dis.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/string.h>
 
Index: trunk/src/VBox/Runtime/testcase/tstLdr.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstLdr.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstLdr.cpp	(revision 76452)
@@ -34,5 +34,5 @@
 #include <iprt/assert.h>
 #include <iprt/initterm.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/string.h>
 
Index: trunk/src/VBox/Runtime/testcase/tstLdrLoad.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstLdrLoad.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstLdrLoad.cpp	(revision 76452)
@@ -29,5 +29,5 @@
 #include <iprt/stream.h>
 #include <iprt/initterm.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 
 int main(int argc, char **argv)
Index: trunk/src/VBox/Runtime/testcase/tstLog.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstLog.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstLog.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/log.h>
 #include <iprt/initterm.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 
 #include <stdio.h>
Index: trunk/src/VBox/Runtime/testcase/tstMove.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstMove.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstMove.cpp	(revision 76452)
@@ -32,5 +32,5 @@
 #include <iprt/path.h>
 #include <iprt/dir.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/initterm.h>
 #include <iprt/stream.h>
Index: trunk/src/VBox/Runtime/testcase/tstOnce.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstOnce.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstOnce.cpp	(revision 76452)
@@ -35,5 +35,5 @@
 #include <iprt/semaphore.h>
 #include <iprt/string.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/asm.h>
 
Index: trunk/src/VBox/Runtime/testcase/tstRTBase64.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTBase64.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTBase64.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/base64.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/initterm.h>
 #include <iprt/stdarg.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTCidr.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTCidr.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTCidr.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/cidr.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/initterm.h>
 #include <iprt/test.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTCircBuf.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTCircBuf.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTCircBuf.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/circbuf.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/string.h>
 #include <iprt/test.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTCoreDump.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTCoreDump.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTCoreDump.cpp	(revision 76452)
@@ -32,5 +32,5 @@
 
 #include <iprt/test.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/initterm.h>
 #include <iprt/thread.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTCritSect.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTCritSect.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTCritSect.cpp	(revision 76452)
@@ -38,5 +38,5 @@
 #include <iprt/assert.h>
 #include <iprt/ctype.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/initterm.h>
 #include <iprt/getopt.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTFileModeStringToFlags.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTFileModeStringToFlags.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTFileModeStringToFlags.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/file.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/stream.h>
 #include <iprt/string.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTFilesystem.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTFilesystem.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTFilesystem.cpp	(revision 76452)
@@ -30,5 +30,5 @@
 *********************************************************************************************************************************/
 #include <iprt/vfs.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/test.h>
 #include <iprt/file.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTFsQueries.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTFsQueries.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTFsQueries.cpp	(revision 76452)
@@ -32,5 +32,5 @@
 #include <iprt/initterm.h>
 #include <iprt/stream.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 
 
Index: trunk/src/VBox/Runtime/testcase/tstRTGetOptArgv.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTGetOptArgv.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTGetOptArgv.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/path.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/getopt.h>
 #include <iprt/ldr.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTHeapOffset.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTHeapOffset.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTHeapOffset.cpp	(revision 76452)
@@ -32,5 +32,5 @@
 
 #include <iprt/assert.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/initterm.h>
 #include <iprt/log.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTHeapSimple.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTHeapSimple.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTHeapSimple.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/heap.h>
 #include <iprt/initterm.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/stream.h>
 #include <iprt/string.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTLdrVerifyPeImage.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTLdrVerifyPeImage.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTLdrVerifyPeImage.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/ldr.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/mem.h>
 #include <iprt/path.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTList.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTList.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTList.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/list.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/mem.h>
 #include <iprt/string.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTMemPool.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTMemPool.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTMemPool.cpp	(revision 76452)
@@ -32,5 +32,5 @@
 
 #include <iprt/asm.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/initterm.h>
 #include <iprt/string.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTMp-1.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTMp-1.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTMp-1.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/mp.h>
 #include <iprt/cpuset.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/string.h>
 #include <iprt/test.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTNetIPv4.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTNetIPv4.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTNetIPv4.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/net.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/initterm.h>
 #include <iprt/test.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTNetIPv6.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTNetIPv6.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTNetIPv6.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/net.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/initterm.h>
 #include <iprt/test.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTNtPath-1.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTNtPath-1.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTNtPath-1.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/nt/nt-and-windows.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/dir.h>
 #include <iprt/env.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTPathGlob.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTPathGlob.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTPathGlob.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/path.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/string.h>
 #include <iprt/test.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTPathQueryInfo.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTPathQueryInfo.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTPathQueryInfo.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/path.h>
 #include <iprt/initterm.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/stream.h>
 #include <iprt/message.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTProcIsRunningByName.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTProcIsRunningByName.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTProcIsRunningByName.cpp	(revision 76452)
@@ -32,5 +32,5 @@
 #include <iprt/initterm.h>
 #include <iprt/stream.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/param.h>
 #include <iprt/path.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTProcQueryUsername.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTProcQueryUsername.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTProcQueryUsername.cpp	(revision 76452)
@@ -30,5 +30,5 @@
 *********************************************************************************************************************************/
 #include <iprt/initterm.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/string.h>
 #include <iprt/process.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTProcWait.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTProcWait.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTProcWait.cpp	(revision 76452)
@@ -35,5 +35,5 @@
 #include <iprt/semaphore.h>
 #include <iprt/env.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/string.h>
 
Index: trunk/src/VBox/Runtime/testcase/tstRTR0DbgKrnlInfoDriver.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTR0DbgKrnlInfoDriver.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTR0DbgKrnlInfoDriver.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/initterm.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/path.h>
 #include <iprt/param.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTR0MemUserKernel.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTR0MemUserKernel.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTR0MemUserKernel.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/mem.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/param.h>
 #include <iprt/time.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTR0MemUserKernelDriver.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTR0MemUserKernelDriver.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTR0MemUserKernelDriver.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/initterm.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/path.h>
 #include <iprt/param.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTR0SemMutex.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTR0SemMutex.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTR0SemMutex.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/semaphore.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <VBox/sup.h>
 #include <iprt/string.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTR0SemMutexDriver.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTR0SemMutexDriver.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTR0SemMutexDriver.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/initterm.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/path.h>
 #include <iprt/param.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTR0Thread.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTR0Thread.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTR0Thread.cpp	(revision 76452)
@@ -32,5 +32,5 @@
 
 #include <iprt/asm-amd64-x86.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <VBox/sup.h>
 #include "tstRTR0Thread.h"
Index: trunk/src/VBox/Runtime/testcase/tstRTR0ThreadDriver.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTR0ThreadDriver.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTR0ThreadDriver.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/initterm.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/path.h>
 #include <iprt/param.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTR0ThreadPreemption.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTR0ThreadPreemption.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTR0ThreadPreemption.cpp	(revision 76452)
@@ -32,5 +32,5 @@
 
 #include <iprt/asm-amd64-x86.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/mem.h>
 #include <iprt/time.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTR0ThreadPreemptionDriver.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTR0ThreadPreemptionDriver.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTR0ThreadPreemptionDriver.cpp	(revision 76452)
@@ -33,5 +33,5 @@
 #include <iprt/asm.h>
 #include <iprt/cpuset.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/path.h>
 #include <iprt/param.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTR0TimerDriver.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTR0TimerDriver.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTR0TimerDriver.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/initterm.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/path.h>
 #include <iprt/param.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTS3.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTS3.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTS3.cpp	(revision 76452)
@@ -32,5 +32,5 @@
 #include <iprt/stream.h>
 #include <iprt/initterm.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/test.h>
 
Index: trunk/src/VBox/Runtime/testcase/tstRTSemEventMulti.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTSemEventMulti.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTSemEventMulti.cpp	(revision 76452)
@@ -33,5 +33,5 @@
 #include <iprt/asm.h>
 #include <iprt/assert.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/rand.h>
 #include <iprt/stream.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTSemXRoads.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTSemXRoads.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTSemXRoads.cpp	(revision 76452)
@@ -32,5 +32,5 @@
 
 #include <iprt/asm.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/initterm.h>
 #include <iprt/test.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTShMem.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTShMem.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTShMem.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/shmem.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/log.h>
 #include <iprt/string.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTSort.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTSort.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTSort.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/sort.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/rand.h>
 #include <iprt/string.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTStrAlloc.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTStrAlloc.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTStrAlloc.cpp	(revision 76452)
@@ -32,5 +32,5 @@
 
 #include <iprt/asm.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/test.h>
 
Index: trunk/src/VBox/Runtime/testcase/tstRTStrCache.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTStrCache.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTStrCache.cpp	(revision 76452)
@@ -33,5 +33,5 @@
 #include <iprt/asm.h>
 #include <iprt/ctype.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/initterm.h>
 #include <iprt/mem.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTStrCatCopy.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTStrCatCopy.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTStrCatCopy.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/string.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/test.h>
 
Index: trunk/src/VBox/Runtime/testcase/tstRTSystemQueryDmi.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTSystemQueryDmi.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTSystemQueryDmi.cpp	(revision 76452)
@@ -32,5 +32,5 @@
 
 #include <iprt/assert.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/string.h>
 #include <iprt/test.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTSystemQueryOsInfo.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTSystemQueryOsInfo.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTSystemQueryOsInfo.cpp	(revision 76452)
@@ -32,5 +32,5 @@
 
 #include <iprt/assert.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/string.h>
 #include <iprt/test.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTTemp.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTTemp.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTTemp.cpp	(revision 76452)
@@ -33,5 +33,5 @@
 #include <iprt/path.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/initterm.h>
 #include <iprt/mem.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTThreadPoke.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTThreadPoke.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTThreadPoke.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/thread.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/test.h>
 #include <iprt/string.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTTime.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTTime.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTTime.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/time.h>
 
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/initterm.h>
 #include <iprt/message.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTVfs.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTVfs.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTVfs.cpp	(revision 76452)
@@ -30,5 +30,5 @@
 *********************************************************************************************************************************/
 #include <iprt/vfs.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/test.h>
 #include <iprt/file.h>
Index: trunk/src/VBox/Runtime/testcase/tstRTZip.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRTZip.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRTZip.cpp	(revision 76452)
@@ -32,5 +32,5 @@
 
 #include <iprt/env.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/initterm.h>
 #include <iprt/file.h>
Index: trunk/src/VBox/Runtime/testcase/tstRand.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstRand.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstRand.cpp	(revision 76452)
@@ -30,5 +30,5 @@
 *********************************************************************************************************************************/
 #include <iprt/rand.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/stream.h>
 #include <iprt/initterm.h>
Index: trunk/src/VBox/Runtime/testcase/tstStrSimplePattern.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstStrSimplePattern.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstStrSimplePattern.cpp	(revision 76452)
@@ -31,5 +31,5 @@
 #include <iprt/string.h>
 #include <iprt/stream.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/initterm.h>
 
Index: trunk/src/VBox/Runtime/testcase/tstTermCallbacks.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstTermCallbacks.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstTermCallbacks.cpp	(revision 76452)
@@ -33,5 +33,5 @@
 #include <iprt/test.h>
 #include <iprt/stream.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/initterm.h>
 
Index: trunk/src/VBox/Runtime/testcase/tstThread-1.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstThread-1.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstThread-1.cpp	(revision 76452)
@@ -32,5 +32,5 @@
 #include <iprt/stream.h>
 #include <iprt/initterm.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 
 
Index: trunk/src/VBox/Runtime/testcase/tstTime-3.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstTime-3.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstTime-3.cpp	(revision 76452)
@@ -34,5 +34,5 @@
 #include <iprt/initterm.h>
 #include <iprt/thread.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 
 
Index: trunk/src/VBox/Runtime/testcase/tstTimer.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstTimer.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstTimer.cpp	(revision 76452)
@@ -35,5 +35,5 @@
 #include <iprt/message.h>
 #include <iprt/stream.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/string.h>
 
Index: trunk/src/VBox/Runtime/testcase/tstTimerLR.cpp
===================================================================
--- trunk/src/VBox/Runtime/testcase/tstTimerLR.cpp	(revision 76417)
+++ trunk/src/VBox/Runtime/testcase/tstTimerLR.cpp	(revision 76452)
@@ -35,5 +35,5 @@
 #include <iprt/message.h>
 #include <iprt/stream.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 
 