Index: trunk/src/VBox/VMM/VMMAll/FTMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/FTMAll.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/VMMAll/FTMAll.cpp	(revision 76454)
@@ -24,5 +24,5 @@
 #include <VBox/vmm/vm.h>
 #include <VBox/vmm/vmm.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/param.h>
 #include <VBox/log.h>
Index: trunk/src/VBox/VMM/VMMAll/HMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/HMAll.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/VMMAll/HMAll.cpp	(revision 76454)
@@ -28,5 +28,5 @@
 #include <VBox/vmm/hm_vmx.h>
 #include <VBox/vmm/hm_svm.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/log.h>
 #include <iprt/param.h>
Index: trunk/src/VBox/VMM/VMMAll/MMAllPagePool.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/MMAllPagePool.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/VMMAll/MMAllPagePool.cpp	(revision 76454)
@@ -29,5 +29,5 @@
 #include <VBox/vmm/vm.h>
 #include <VBox/param.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/log.h>
 #include <iprt/alloc.h>
Index: trunk/src/VBox/VMM/VMMAll/PDMAllCritSectBoth.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PDMAllCritSectBoth.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/VMMAll/PDMAllCritSectBoth.cpp	(revision 76454)
@@ -25,5 +25,5 @@
 #include <VBox/vmm/pdmcritsectrw.h>
 #include <VBox/vmm/vm.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 
 #include <VBox/log.h>
Index: trunk/src/VBox/VMM/VMMAll/PDMAllQueue.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/PDMAllQueue.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/VMMAll/PDMAllQueue.cpp	(revision 76454)
@@ -30,5 +30,5 @@
 #endif
 #include <VBox/vmm/vm.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/log.h>
 #include <iprt/asm.h>
Index: trunk/src/VBox/VMM/VMMAll/REMAll.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMAll/REMAll.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/VMMAll/REMAll.cpp	(revision 76454)
@@ -28,5 +28,5 @@
 #include "REMInternal.h"
 #include <VBox/vmm/vm.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/log.h>
 
Index: trunk/src/VBox/VMM/VMMR0/EMR0.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR0/EMR0.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/VMMR0/EMR0.cpp	(revision 76454)
@@ -25,5 +25,5 @@
 #include <VBox/vmm/vm.h>
 #include <VBox/vmm/gvm.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/log.h>
 #include <iprt/assert.h>
Index: trunk/src/VBox/VMM/VMMR0/PDMR0Driver.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR0/PDMR0Driver.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/VMMR0/PDMR0Driver.cpp	(revision 76454)
@@ -27,5 +27,5 @@
 
 #include <VBox/log.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <iprt/assert.h>
 
Index: trunk/src/VBox/VMM/VMMR0/TRPMR0.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR0/TRPMR0.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/VMMR0/TRPMR0.cpp	(revision 76454)
@@ -25,5 +25,5 @@
 #include <VBox/vmm/vm.h>
 #include <VBox/vmm/vmm.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/log.h>
 #include <iprt/assert.h>
Index: trunk/src/VBox/VMM/VMMR3/DBGFCpu.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/DBGFCpu.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/VMMR3/DBGFCpu.cpp	(revision 76454)
@@ -27,5 +27,5 @@
 #include <VBox/vmm/vm.h>
 #include <VBox/vmm/uvm.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/log.h>
 #include <VBox/param.h>
Index: trunk/src/VBox/VMM/VMMR3/MMHeap.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/MMHeap.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/VMMR3/MMHeap.cpp	(revision 76454)
@@ -27,5 +27,5 @@
 #include <VBox/vmm/vm.h>
 #include <VBox/vmm/uvm.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/param.h>
 #include <VBox/log.h>
Index: trunk/src/VBox/VMM/VMMR3/MMPagePool.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/MMPagePool.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/VMMR3/MMPagePool.cpp	(revision 76454)
@@ -27,5 +27,5 @@
 #include <VBox/vmm/vm.h>
 #include <VBox/param.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/log.h>
 #include <iprt/alloc.h>
Index: trunk/src/VBox/VMM/VMMR3/MMUkHeap.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/MMUkHeap.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/VMMR3/MMUkHeap.cpp	(revision 76454)
@@ -26,5 +26,5 @@
 #include <VBox/vmm/vm.h>
 #include <VBox/vmm/uvm.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/param.h>
 #include <VBox/log.h>
Index: trunk/src/VBox/VMM/VMMR3/PATMR3Dbg.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/PATMR3Dbg.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/VMMR3/PATMR3Dbg.cpp	(revision 76454)
@@ -27,5 +27,5 @@
 #include "PATMA.h"
 #include <VBox/vmm/vm.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/log.h>
 
Index: trunk/src/VBox/VMM/VMMR3/PDMQueue.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMR3/PDMQueue.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/VMMR3/PDMQueue.cpp	(revision 76454)
@@ -29,5 +29,5 @@
 #include <VBox/vmm/vm.h>
 #include <VBox/vmm/uvm.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 
 #include <VBox/log.h>
Index: trunk/src/VBox/VMM/VMMRC/PGMRC.cpp
===================================================================
--- trunk/src/VBox/VMM/VMMRC/PGMRC.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/VMMRC/PGMRC.cpp	(revision 76454)
@@ -39,5 +39,5 @@
 #include <VBox/log.h>
 #include <VBox/param.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/dis.h>
 #include <VBox/disopcode.h>
Index: trunk/src/VBox/VMM/testcase/tstGlobalConfig.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstGlobalConfig.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/testcase/tstGlobalConfig.cpp	(revision 76454)
@@ -21,5 +21,5 @@
 *********************************************************************************************************************************/
 #include <VBox/vmm/vmm.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <iprt/assert.h>
 #include <iprt/initterm.h>
Index: trunk/src/VBox/VMM/testcase/tstMMHyperHeap.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstMMHyperHeap.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/testcase/tstMMHyperHeap.cpp	(revision 76454)
@@ -26,5 +26,5 @@
 #include <VBox/sup.h>
 #include <VBox/param.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 
 #include <VBox/log.h>
Index: trunk/src/VBox/VMM/testcase/tstMicro.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstMicro.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/testcase/tstMicro.cpp	(revision 76454)
@@ -27,5 +27,5 @@
 #include <VBox/vmm/dbgf.h>
 #include <VBox/vmm/pgm.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/param.h>
 
Index: trunk/src/VBox/VMM/testcase/tstMicroRC.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstMicroRC.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/testcase/tstMicroRC.cpp	(revision 76454)
@@ -25,5 +25,5 @@
 #include "tstMicro.h"
 
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <iprt/asm-amd64-x86.h>
 #include <VBox/log.h>
Index: trunk/src/VBox/VMM/testcase/tstPDMAsyncCompletion.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstPDMAsyncCompletion.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/testcase/tstPDMAsyncCompletion.cpp	(revision 76454)
@@ -33,5 +33,5 @@
 #include <VBox/vmm/vmm.h>
 #include <VBox/vmm/cpum.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/log.h>
 #include <VBox/vmm/pdmapi.h>
Index: trunk/src/VBox/VMM/testcase/tstSSM-2.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstSSM-2.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/testcase/tstSSM-2.cpp	(revision 76454)
@@ -24,5 +24,5 @@
 #include <VBox/log.h>
 #include <iprt/getopt.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/file.h>
 #include <iprt/path.h>
Index: trunk/src/VBox/VMM/testcase/tstVMM-HM.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstVMM-HM.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/testcase/tstVMM-HM.cpp	(revision 76454)
@@ -23,5 +23,5 @@
 #include <VBox/vmm/vmm.h>
 #include <VBox/vmm/cpum.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/log.h>
 #include <iprt/assert.h>
Index: trunk/src/VBox/VMM/testcase/tstVMM.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstVMM.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/testcase/tstVMM.cpp	(revision 76454)
@@ -25,5 +25,5 @@
 #include <VBox/vmm/tm.h>
 #include <VBox/vmm/pdmapi.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/log.h>
 #include <iprt/assert.h>
Index: trunk/src/VBox/VMM/testcase/tstVMMFork.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstVMMFork.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/testcase/tstVMMFork.cpp	(revision 76454)
@@ -22,5 +22,5 @@
 #include <VBox/vmm/vm.h>
 #include <VBox/vmm/vmm.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/log.h>
 #include <iprt/assert.h>
Index: trunk/src/VBox/VMM/testcase/tstVMMR0CallHost-1.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstVMMR0CallHost-1.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/testcase/tstVMMR0CallHost-1.cpp	(revision 76454)
@@ -20,5 +20,5 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/param.h>
 #include <iprt/alloca.h>
Index: trunk/src/VBox/VMM/testcase/tstVMREQ.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstVMREQ.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/testcase/tstVMREQ.cpp	(revision 76454)
@@ -23,5 +23,5 @@
 #include <VBox/vmm/vmm.h>
 #include <VBox/vmm/cpum.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #include <VBox/log.h>
 #include <iprt/assert.h>
Index: trunk/src/VBox/VMM/testcase/tstX86-1.cpp
===================================================================
--- trunk/src/VBox/VMM/testcase/tstX86-1.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/testcase/tstX86-1.cpp	(revision 76454)
@@ -23,5 +23,5 @@
 #include <iprt/param.h>
 #include <iprt/mem.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/assert.h>
 #include <iprt/x86.h>
Index: trunk/src/VBox/VMM/tools/VBoxCpuReportMsrSup.cpp
===================================================================
--- trunk/src/VBox/VMM/tools/VBoxCpuReportMsrSup.cpp	(revision 76435)
+++ trunk/src/VBox/VMM/tools/VBoxCpuReportMsrSup.cpp	(revision 76454)
@@ -21,5 +21,5 @@
 *********************************************************************************************************************************/
 #include "VBoxCpuReport.h"
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/x86.h>
 