Index: trunk/src/VBox/ValidationKit/utils/audio/ntPlayToneWaveX.cpp
===================================================================
--- trunk/src/VBox/ValidationKit/utils/audio/ntPlayToneWaveX.cpp	(revision 76389)
+++ trunk/src/VBox/ValidationKit/utils/audio/ntPlayToneWaveX.cpp	(revision 76474)
@@ -35,5 +35,5 @@
 #include <iprt/message.h>
 #include <iprt/stream.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 
 #define _USE_MATH_DEFINES
Index: trunk/src/VBox/ValidationKit/utils/cpu/cidet-core.cpp
===================================================================
--- trunk/src/VBox/ValidationKit/utils/cpu/cidet-core.cpp	(revision 76389)
+++ trunk/src/VBox/ValidationKit/utils/cpu/cidet-core.cpp	(revision 76474)
@@ -68,5 +68,5 @@
 #include <iprt/param.h>
 #include <iprt/string.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 #if defined(CIDET_DPRINTF_ENABLED) || defined(CIDET_DEBUG_DISAS)
 # include <VBox/dis.h>
Index: trunk/src/VBox/ValidationKit/utils/misc/loadgenerator.cpp
===================================================================
--- trunk/src/VBox/ValidationKit/utils/misc/loadgenerator.cpp	(revision 76389)
+++ trunk/src/VBox/ValidationKit/utils/misc/loadgenerator.cpp	(revision 76474)
@@ -29,5 +29,5 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/thread.h>
 #include <iprt/time.h>
Index: trunk/src/VBox/ValidationKit/utils/misc/loadgeneratorR0.cpp
===================================================================
--- trunk/src/VBox/ValidationKit/utils/misc/loadgeneratorR0.cpp	(revision 76389)
+++ trunk/src/VBox/ValidationKit/utils/misc/loadgeneratorR0.cpp	(revision 76474)
@@ -31,5 +31,5 @@
 #include <iprt/mp.h>
 #include <VBox/sup.h>
-#include <VBox/err.h>
+#include <iprt/errcore.h>
 
 
Index: trunk/src/VBox/ValidationKit/utils/misc/vts_rm.cpp
===================================================================
--- trunk/src/VBox/ValidationKit/utils/misc/vts_rm.cpp	(revision 76389)
+++ trunk/src/VBox/ValidationKit/utils/misc/vts_rm.cpp	(revision 76474)
@@ -30,5 +30,5 @@
 *********************************************************************************************************************************/
 #include <iprt/path.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/initterm.h>
 #include <iprt/message.h>
Index: trunk/src/VBox/ValidationKit/utils/misc/vts_tar.cpp
===================================================================
--- trunk/src/VBox/ValidationKit/utils/misc/vts_tar.cpp	(revision 76389)
+++ trunk/src/VBox/ValidationKit/utils/misc/vts_tar.cpp	(revision 76474)
@@ -30,5 +30,5 @@
 *********************************************************************************************************************************/
 #include <iprt/zip.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/initterm.h>
 #include <iprt/message.h>
Index: trunk/src/VBox/ValidationKit/utils/nt/ntsetfreq.cpp
===================================================================
--- trunk/src/VBox/ValidationKit/utils/nt/ntsetfreq.cpp	(revision 76389)
+++ trunk/src/VBox/ValidationKit/utils/nt/ntsetfreq.cpp	(revision 76474)
@@ -37,5 +37,5 @@
 #include <iprt/string.h>
 #include <iprt/thread.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 
 
Index: trunk/src/VBox/ValidationKit/utils/nt/nttimesources.cpp
===================================================================
--- trunk/src/VBox/ValidationKit/utils/nt/nttimesources.cpp	(revision 76389)
+++ trunk/src/VBox/ValidationKit/utils/nt/nttimesources.cpp	(revision 76474)
@@ -33,5 +33,5 @@
 #include <iprt/asm.h>
 #include <iprt/asm-amd64-x86.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/string.h>
 #include <iprt/test.h>
Index: trunk/src/VBox/ValidationKit/utils/serial/SerialTest.cpp
===================================================================
--- trunk/src/VBox/ValidationKit/utils/serial/SerialTest.cpp	(revision 76389)
+++ trunk/src/VBox/ValidationKit/utils/serial/SerialTest.cpp	(revision 76474)
@@ -29,5 +29,5 @@
 *   Header Files                                                                                                                 *
 *********************************************************************************************************************************/
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/getopt.h>
 #include <iprt/mem.h>
Index: trunk/src/VBox/ValidationKit/utils/usb/UsbTestServiceGadget.cpp
===================================================================
--- trunk/src/VBox/ValidationKit/utils/usb/UsbTestServiceGadget.cpp	(revision 76389)
+++ trunk/src/VBox/ValidationKit/utils/usb/UsbTestServiceGadget.cpp	(revision 76474)
@@ -31,5 +31,5 @@
 #include <iprt/asm.h>
 #include <iprt/ctype.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/mem.h>
 #include <iprt/string.h>
Index: trunk/src/VBox/ValidationKit/utils/usb/UsbTestServiceGadgetHost.cpp
===================================================================
--- trunk/src/VBox/ValidationKit/utils/usb/UsbTestServiceGadgetHost.cpp	(revision 76389)
+++ trunk/src/VBox/ValidationKit/utils/usb/UsbTestServiceGadgetHost.cpp	(revision 76474)
@@ -31,5 +31,5 @@
 #include <iprt/asm.h>
 #include <iprt/ctype.h>
-#include <iprt/err.h>
+#include <iprt/errcore.h>
 #include <iprt/mem.h>
 #include <iprt/string.h>